{ Pe un teren de forma dreptunghiulara a[m,n] au cazut p bombe la coordonate
  x[i] si y[i] pentru bomba cu numarul de ordine i ( unde i=1,p).
  Fiecare bomba a contaminat o zona de forma patrata cu centrul in locul unde
  a cazut bomba si cu latura de masura data de valoarea 2*t[i]+1 pentru bomba
  cu numarul de ordine i ( unde i=1,p ).
 In fiecare zi, zona de contaminare a terenului scade, devenind un patrat de
  latura mai mica cu doua unitati fata de ziua precedenta.
 Misiunea unui cercetas este de a gasi un traseu de lungime (minima) ce incepe
  in punctul de pe latura de vest a[v,1] si traverseaza
  terenul fara sa-l paraseasca si fara sa treaca de doua ori prin aceeasi
  pozitie pana la alt punct a[e,n] situat pe latura de est, fara a se expune
  radiatiilor, in prima zi cand se va putea faca traversarea.
  Drumul trebuie sa urmeze doar directiile: nord, sud, est si vest.
 Valori maxime: m=20, n=20, p=50, iar vectorul t contine valori pana la 100.
 Intrarea datelor se face din fisierul text "teren.in", iar iesirea se face in
  fisierul "teren.out" .
  Fisierul de intrare contine:
m n p                        pe prima linie, separate de un spatiu;
x[1] x[2] ... x[p]           liniile celor p bombe;
y[1] y[2] ... y[p]           coloanele celor p bombe;
t[1] t[2] ... t[p]           puterea de contaminare a celor p bombe
v e                          liniile de intrare , respectiv iesire din teren
 Fisierul de iesire va contine :
  pe prima linie numarul zilei in care se face traversarea,
  iar in urmatoarele zile, matricea a[m,n], cate o linie a matricii pe o linie
  de fisier( elementele unei linii nefiind separate ), iar matricea va contine:
        -  caracterul spatiu pentru casutele necontaminate,
        -  caracterul punct pentru cele contaminate si
        -  caracterul X pentru traseul ales.
 Nota: pentru valorile maxime date mai sus, timpul maxim de executie trebuie
  sa fie de 10 secunde pentru un "Pentium" la 233 MHz.
                                                         }
uses crt;
type matrice=array[0..21,0..21] of integer;
     vect=array[1..20] of integer;
var a,aa:matrice;
    i,j,m,n,p,v,e,nz:integer;
    t,x,y:vect;
    f:text;      ok:boolean;

procedure citeste;
begin
   assign(f,'TEREN4.IN');reset(f);
   readln(f,m,n,p);
   for i:=1 to p do read(f,x[i]);readln(f);
   for i:=1 to p do read(f,y[i]);readln(f);
   for i:=1 to p do read(f,t[i]);readln(f);
   readln(f,v,e);
   close(f);
   for i:=1 to m do for j:=1 to n do a[i,j]:=0;
   for i:=1 to p do a[x[i],y[i]]:=t[i];
end;


procedure scrie(a:matrice);
begin
   for i:=1 to m do
      begin
         for j:=1 to n do
            begin
               if ((i=v) and (j=1)) or ((i=e) and (j=n))
                  then textcolor(yellow)
                  else textcolor(white);
               write(a[i,j]:4);
            end;
         writeln
      end;
   textcolor(white);
end;


procedure contamineaza;
var x1,y1:integer;
begin
   for i:=1 to p do
      if (t[i]>0)
         then
            for x1:=x[i]-t[i] to x[i]+t[i] do
               for y1:=y[i]-t[i] to y[i]+t[i] do
                  if (x1>=1) and (x1<=m) and (y1>=1) and (y1<=n)
                     then
                        if a[x1,y1]<t[i]
                           then a[x1,y1]:=t[i];
end;

procedure decontamineaza;
var i,k:integer;

begin
   citeste;
   for k:=1 to nz do
      for i:=1 to p do if t[i]>0 then dec(t[i]);
   for i:=1 to p do write(' bomba ',i,':',t[i]:4,',');writeln;
   contamineaza;
end;

procedure umple(x,y:integer; var aa:matrice);
begin
   if aa[x,y]=0 then
      begin
         aa[x,y]:=101;umple(x-1,y,aa);umple(x+1,y,aa);
         umple(x,y-1,aa);umple(x,y+1,aa);
      end;
end;

procedure drum;
begin
   for i:=1 to m do for j:=1 to n do aa[i,j]:=a[i,j]; { copiere a in aa }
   for i:=0 to m+1 do begin aa[i,0]:=102;aa[i,n+1]:=102 end;
   for i:=0 to n+1 do begin aa[0,i]:=102;aa[m+1,i]:=102 end; { bordare aa }
   umple(v,1,aa);         { umplu ce pot in aa cu 101 }
   if aa[e,n]=101         { daca a ajuns val 101 la iesire, este ok }
      then ok:=true;
  { writeln('Matricea aa dupa inca o decontaminare(ziua a ',nz,'-a');
   writeln('Am gasit aa[',e,',',n,']=',a[e,n],', deci ok=',ok);
   for i:=0 to m+1 do
      begin for j:=0 to n+1 do write(aa[i,j]:5); writeln end;
   readln;    }
end;

begin
   clrscr;citeste;
   writeln('Terenul citit din fisier :');scrie(a);
   contamineaza;
   writeln('Terenul,dupa contaminare( in ziua 0):'); scrie(a);readln;
   nz:=0;
   while (a[v,1]<>0) or (a[e,n]<>0) do
      begin
         inc(nz);decontamineaza;
         writeln('a, dupa ',nz,' zile:');scrie(a);readln;
      end;
   writeln('Dupa cum se vede mai sus, se poate intra si iesi in/din teren,');
   writeln('dar nu neaparat sa se si traverseze.');
     ok:=false;
     drum;                 { intoarce ok/nu}
     while not ok do
        begin
            inc(nz);
            decontamineaza;
            scrie(a);readln;
            drum;
        end;
     writeln('IESIRE POSIBILA ( dupa ',nz,', zile ) : ');
     writeln('Intrare in linia ',v,', iar iesire la linia ',e);
   readln;
end.